mod Ex03b

incl Mtex

loc rem 
  \para \bf  3. CVIČENIE Z PREDMETU 1-INF-465 DEKLARATÍVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Dátum:  \end piatok 4.3.2011 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/1011ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované klauzálnym 
  definíciam, chvostovej rekurzii a celočíselnej odmocnine. Zadanie sa 
  skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [2]  \end J. Kľuka. Lecture Notes from Introduction to 
         Declarative Programming Summer 2010/11. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Tail Recursion and Iteration.  \end See also in [1]: 
  \items 
   \item \para the paragraph \it  Fibonacci function  \end in the section \it  
         Primitive Recursion  \end and 
   \item \para the paragraph \it  Simulation of for-loops by recursion  \end in 
         the section \it  Course of Values Recursion  \end. 
  \end

rem 
  \para \bf  Exercise.  \end Find an efficient, tail recursive implementation of 
  the function: 

fun F1 'Tex_f1_f_sub'
  F1(0) = 0
  F1(1) = 1
  F1(n+2) = F1(n+1)+F1(n)

rem 
  \para Your solution should simulate the following while-loop by primitive 
  recursion: 
  \verbatim 
  if n = 0 then return(0)
  else begin
   n,a,b := n-1,1,0;
   while n <> 0 do n,a,b := n-1,a+b,a;
   return(a)
  end
  \end

rem 
  \para \it  While-loop by primitive recursion.  \end 

fun/3 While1 'Tex_f3_g'
  While1(n,a,b) = Foo

rem 
  \para Invariant: 
  \eq* 
    While1(n,F1(i+1),F1(i)) = F1(n+1+i)
  \end

fun F1_efficient 'Tex_f1_f_sub'
  F1_efficient(n) = Foo

rem 
  \para \bf  Exercise.  \end Find a similar tail recursive implementation of the 
  next function: 

fun F2 'Tex_f1_f_sub'
  F2(0) = 0
  F2(1) = 1
  F2(2) = 2
  F2(n+3) = F2(n+2)+F2(n+1)+F2(n)

rem 
  \para \it  While-loop by primitive recursion.  \end 

fun/4 While2 'Tex_f4_g'
  While2(n,a,b,c) = Foo

rem 
  \para Invariant: 
  \eq* 
    While2(n,F2(i+2),F2(i+1),F2(i)) = F2(n+2+i)
  \end

fun F2_efficient 'Tex_f1_f_sub'
  F2_efficient(n) = Foo

rem 
  \para \bf  Exercise.  \end Find an efficient, tail recursive implementation of 
  the function: 

fun F3 'Tex_f1_f_sub'
  F3(0) = 0
  F3(1) = 1
  F3(n+2) = F3(n+1)+F3(n)+n

rem 
  \para Your solution should simulate the following for-loop by backward 
  recursion: 
  \verbatim 
  if n = 0 then return(0)
  else if n = 1 then return(1)
  else begin
   n,a,b := n-2,1,0;
   for i = 0 to n do a,b := a+b+i,a;
   return(a)
  end
  \end

rem 
  \para \it  For-loop by backward recursion.  \end 

fun/4 For3 'Tex_f4_g'
  For3(i,n,a,b) = Foo

rem 
  \para Invariant: 
  \eq* 
    i <= n+1 -> For3(i,n,F3(i+1),F3(i)) = F3(n+2)
  \end

fun F3_efficient 'Tex_f1_f_sub'
  F3_efficient(n) = Foo

rem 
  \para \bf  Exercise.  \end Find a similar tail recursive implementation of the 
  next function: 

fun F4 'Tex_f1_f_sub'
  F4(0) = 0
  F4(1) = 1
  F4(2) = 2
  F4(n+3) = F4(n+2)+F4(n+1)+F4(n)+n

rem 
  \para \it  For-loop by backward recursion.  \end 

fun/5 For4 'Tex_f5_g'
  For4(i,n,a,b,c) = Foo

rem 
  \para Invariant: 
  \eq* 
    i <= n+1 -> For4(i,n,F4(i+2),F4(i+1),F4(i)) = F4(n+3)
  \end

fun F4_efficient 'Tex_f1_f_sub'
  F4_efficient(n) = Foo

