mod Ex03a

incl Mtex

loc rem 
  \para \bf  3. CVIČENIE Z PREDMETU 1-INF-465 DEKLARATÍVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Dátum:  \end piatok 4.3.2011 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/1011ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované klauzálnym 
  definíciam, chvostovej rekurzii a celočíselnej odmocnine. Zadanie sa 
  skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [2]  \end J. Kľuka. Lecture Notes from Introduction to 
         Declarative Programming Summer 2010/11. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/1 Tex_f1_n_char_even
  Prefix(100,2,Subsup(Id(1,'Even',0),75,Op('*',0),None),Arg(0))

appldisp/1 Tex_f1_n_char_odd
  Prefix(100,2,Subsup(Id(1,'Odd',0),75,Op('*',0),None),Arg(0))

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Clausal Definitions.  \end 

rem 
  \para \bf  Subsection. Clausal Definitions of Functions.  \end 

rem 
  \para \bf  Summation.  \end The following component contains a primitive 
  recursive definition of the summation function \ft Tex_f1_n_sum(n) \end. 
  \para \it  Remark.  \end Note that the definition is a special case of regular 
  recursive clausal definition with monadic discrimination. 

fun Sum 'Tex_f1_n_sum'
  Sum(0) = 0
  Sum(n+1) = Sum(n)+n+1

rem 
  \para \bf  Factorial.  \end Find a primitive recursive definition of the 
  factorial function \ft Tex_f1_n_fact(n) \end. 

fun Fact 'Tex_f1_n_fact'
  Fact(n) = Foo

rem 
  \para \bf  Exponentiation.  \end Find a primitive recursive definition of the 
  exponentiation function \ft Tex_f2_n_exp(x,y) \end. 

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,y) = Foo

rem 
  \para \bf  Fibonacci sequence.  \end \header* fun Fib 'Tex_f1_n_fib' \end Find 
  a course of values recursive definition of the function \ft Fib(n) \end which 
  computes the \ft n \end-th element of the Fibonacci sequence. 

fun Fib 'Tex_f1_n_fib'
  Fib(n) = Foo

rem 
  \para \bf  Subsection. Clausal Definitions of Predicates.  \end 

rem 
  \para \bf  Exercise.  \end \header* fun Evenf 'Tex_f1_n_char_even' \end Find a 
  primitive recursive definition of the characteristic function 
  \ft Evenf(x) \end of the predicate 
  \eq* 
    Even(x) <-> \e y x = 2*y
  \end
  \para which is based on the property 
  \eq* 
    Even(x) <-> x = 0 \/ \e y(x = y+1 & ~Even(y))
  \end
  \para Do not use default clauses! 

fun Evenf 'Tex_f1_n_char_even'
  Evenf(x) = Foo

rem 
  \para \bf  Exercise.  \end Transform the above function clausal definition to 
  a predicate clausal definition. 
  \para \it  Hint.  \end Recall that we have 
  \eq* 
    Even(x) <-> Evenf(x) = 1 & Even(x) <-> Evenf(x) != 0
  \end
  \eq* 
    ~Even(x) <-> Evenf(x) = 0 & ~Even(x) <-> Evenf(x) != 1
  \end

pred Even 
  Even(x) <-> Poo

rem 
  \para \bf  Exercise.  \end \header* fun Oddf 'Tex_f1_n_char_odd' \end Find a 
  course of values recursive definition of the characteristic function 
  \ft Oddf(x) \end of the predicate 
  \eq* 
    Odd(x) <-> \e y x = 2*y+1
  \end
  \para which is based on the property 
  \eq* 
    Odd(x) <-> x = 1 \/ \e y(x = y+2 & Odd(y))
  \end
  \para Do not use default clauses! 

fun Oddf 'Tex_f1_n_char_odd'
  Oddf(x) = Foo

rem 
  \para \bf  Exercise.  \end Transform the above function clausal definition to 
  a predicate clausal definition. 

pred Odd 
  Odd(x) <-> Poo

